diff --git a/content/common/media/media_channel.cc b/content/common/media/media_channel.cc
new file mode 100644
index 0000000..414c1b4
--- /dev/null
+++ b/content/common/media/media_channel.cc
@@ -0,0 +1,369 @@
+// Copyright (c) 2015 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#include "content/common/media/media_channel.h"
+
+#include <queue>
+#include <vector>
+
+#include "base/bind.h"
+#include "base/command_line.h"
+#include "base/stl_util.h"
+#include "base/strings/string_util.h"
+#include "base/timer/timer.h"
+#include "base/trace_event/trace_event.h"
+#include "content/public/common/content_switches.h"
+#include "content/child/child_process.h"
+#include "ipc/ipc_channel.h"
+#include "ipc/ipc_message_macros.h"
+#include "ipc/message_filter.h"
+#include "content/common/media/media_channel_filter.h"
+#include "content/common/media/media_player_messages_gstreamer.h"
+#include "content/media/gstreamer/media_player_gstreamer.h"
+
+#if defined(OS_POSIX)
+#include "ipc/ipc_channel_posix.h"
+#endif
+
+namespace content {
+
+MediaChannel::MediaChannel(int client_id, MediaChannelFilter* channel_filter)
+    : client_id_(client_id), channel_filter_(channel_filter) {
+  DCHECK(client_id);
+
+  channel_id_ = IPC::Channel::GenerateVerifiedChannelID("media");
+}
+
+MediaChannel::~MediaChannel() {}
+
+void MediaChannel::Init(base::SingleThreadTaskRunner* io_task_runner,
+                        base::WaitableEvent* shutdown_event) {
+  DCHECK(!channel_.get());
+
+  // Map renderer ID to a (single) channel to that process.
+  channel_ =
+      IPC::SyncChannel::Create(channel_id_, IPC::Channel::MODE_SERVER, this,
+                               io_task_runner, false, shutdown_event);
+}
+
+std::string MediaChannel::GetChannelName() {
+  return channel_id_;
+}
+
+#if defined(OS_POSIX)
+base::ScopedFD MediaChannel::TakeRendererFileDescriptor() {
+  if (!channel_) {
+    NOTREACHED();
+    return base::ScopedFD();
+  }
+  return channel_->TakeClientFileDescriptor();
+}
+#endif  // defined(OS_POSIX)
+
+bool MediaChannel::OnMessageReceived(const IPC::Message& message) {
+  bool handled = true;
+
+  IPC_BEGIN_MESSAGE_MAP(MediaChannel, message)
+    IPC_MESSAGE_HANDLER(MediaPlayerMsg_Create, OnMediaPlayerCreate)
+    IPC_MESSAGE_HANDLER(MediaPlayerMsg_Load, OnMediaPlayerLoad)
+    IPC_MESSAGE_HANDLER(MediaPlayerMsg_Start, OnMediaPlayerStart)
+    IPC_MESSAGE_HANDLER(MediaPlayerMsg_Pause, OnMediaPlayerPause)
+    IPC_MESSAGE_HANDLER(MediaPlayerMsg_Seek, OnMediaPlayerSeek)
+    IPC_MESSAGE_HANDLER(MediaPlayerMsg_Release, OnMediaPlayerRelease)
+    IPC_MESSAGE_HANDLER(MediaPlayerMsg_ReleaseTexture,
+                        OnMediaPlayerReleaseTexture)
+    IPC_MESSAGE_HANDLER(MediaPlayerMsg_AddSourceId, OnMediaPlayerAddSourceId)
+    IPC_MESSAGE_HANDLER(MediaPlayerMsg_RemoveSourceId,
+                        OnMediaPlayerRemoveSourceId)
+    IPC_MESSAGE_HANDLER(MediaPlayerMsg_SetDuration, OnMediaPlayerSetDuration)
+    IPC_MESSAGE_HANDLER(MediaPlayerMsg_MarkEndOfStream,
+                        OnMediaPlayerMarkEndOfStream)
+    IPC_MESSAGE_HANDLER(MediaPlayerMsg_UnmarkEndOfStream,
+                        OnMediaPlayerUnmarkEndOfStream)
+    IPC_MESSAGE_HANDLER(MediaPlayerMsg_SetSequenceMode,
+                        OnMediaPlayerSetSequenceMode)
+    IPC_MESSAGE_HANDLER(MediaPlayerMsg_AppendData, OnMediaPlayerAppendData)
+    IPC_MESSAGE_HANDLER(MediaPlayerMsg_Abort, OnMediaPlayerAbort)
+    IPC_MESSAGE_HANDLER(MediaPlayerMsg_SetGroupStartTimestampIfInSequenceMode,
+                        OnMediaPlayerSetGroupStartTimestampIfInSequenceMode)
+    IPC_MESSAGE_HANDLER(MediaPlayerMsg_RemoveSegment,
+                        OnMediaPlayerRemoveSegment)
+    IPC_MESSAGE_HANDLER(MediaPlayerMsg_AddKey, OnMediaPlayerAddKey)
+    IPC_MESSAGE_UNHANDLED(handled = false)
+  IPC_END_MESSAGE_MAP()
+  return handled;
+}
+
+void MediaChannel::OnChannelError() {
+  channel_filter_->RemoveChannel(client_id_);
+}
+
+MediaPlayerGStreamer* MediaChannel::GetMediaPlayer(int player_id) {
+  MediaPlayerMap::const_iterator iter = media_players_.find(player_id);
+  if (iter != media_players_.end())
+    return iter->second;
+
+  scoped_ptr<MediaPlayerGStreamer> player(
+      channel_filter_->GetMediaPlayerFactory()->create(player_id, this));
+  media_players_.set(player_id, player.Pass());
+  return media_players_.find(player_id)->second;
+}
+
+void MediaChannel::OnMediaPlayerCreate(int player_id) {
+  MediaPlayerGStreamer* player = GetMediaPlayer(player_id);
+  if (!player) {
+    SendMediaError(player_id, 0);
+  }
+}
+
+void MediaChannel::OnMediaPlayerLoad(int player_id, GURL url, unsigned position_update_interval_ms) {
+  MediaPlayerGStreamer* player = GetMediaPlayer(player_id);
+  if (player) {
+    player->Load(url, position_update_interval_ms);
+  }
+}
+
+void MediaChannel::OnMediaPlayerStart(int player_id) {
+  MediaPlayerGStreamer* player = GetMediaPlayer(player_id);
+  if (player) {
+    player->Play();
+  }
+}
+
+void MediaChannel::OnMediaPlayerPause(int player_id) {
+  MediaPlayerGStreamer* player = GetMediaPlayer(player_id);
+  if (player) {
+    player->Pause();
+  }
+}
+
+void MediaChannel::OnMediaPlayerSeek(int player_id, base::TimeDelta delta) {
+  MediaPlayerGStreamer* player = GetMediaPlayer(player_id);
+  if (player) {
+    player->Seek(delta);
+  }
+}
+
+void MediaChannel::OnMediaPlayerRelease(int player_id) {
+  media_players_.erase(player_id);
+}
+
+void MediaChannel::OnMediaPlayerReleaseTexture(int player_id,
+                                               unsigned texture_id) {
+  MediaPlayerGStreamer* player = GetMediaPlayer(player_id);
+  if (player) {
+    player->ReleaseTexture(texture_id);
+  }
+}
+
+void MediaChannel::OnMediaPlayerAddSourceId(
+    int player_id,
+    const std::string& source_id,
+    const std::string& type,
+    const std::vector<std::string>& codecs) {
+  MediaPlayerGStreamer* player = GetMediaPlayer(player_id);
+  if (player) {
+    player->AddSourceId(source_id, type, codecs);
+  }
+}
+
+void MediaChannel::OnMediaPlayerRemoveSourceId(int player_id,
+                                               const std::string& source_id) {
+  MediaPlayerGStreamer* player = GetMediaPlayer(player_id);
+  if (player) {
+    player->RemoveSourceId(source_id);
+  }
+}
+
+void MediaChannel::OnMediaPlayerSetDuration(int player_id,
+                                            const base::TimeDelta& duration) {
+  MediaPlayerGStreamer* player = GetMediaPlayer(player_id);
+  if (player) {
+    player->SetDuration(duration);
+  }
+}
+
+void MediaChannel::OnMediaPlayerMarkEndOfStream(int player_id) {
+  MediaPlayerGStreamer* player = GetMediaPlayer(player_id);
+  if (player) {
+    player->MarkEndOfStream();
+  }
+}
+
+void MediaChannel::OnMediaPlayerUnmarkEndOfStream(int player_id) {
+  MediaPlayerGStreamer* player = GetMediaPlayer(player_id);
+  if (player) {
+    player->UnmarkEndOfStream();
+  }
+}
+
+void MediaChannel::OnMediaPlayerSetSequenceMode(int player_id,
+                                                const std::string& source_id,
+                                                bool sequence_mode) {
+  MediaPlayerGStreamer* player = GetMediaPlayer(player_id);
+  if (player) {
+    player->SetSequenceMode(source_id, sequence_mode);
+  }
+}
+
+void MediaChannel::OnMediaPlayerAppendData(
+    int player_id,
+    const std::string& source_id,
+    const std::vector<unsigned char>& data,
+    const std::vector<base::TimeDelta>& times) {
+  MediaPlayerGStreamer* player = GetMediaPlayer(player_id);
+  if (player) {
+    player->AppendData(source_id, data, times);
+  }
+}
+
+void MediaChannel::OnMediaPlayerAbort(int player_id,
+                                      const std::string& source_id) {
+  MediaPlayerGStreamer* player = GetMediaPlayer(player_id);
+  if (player) {
+    player->Abort(source_id);
+  }
+}
+
+void MediaChannel::OnMediaPlayerSetGroupStartTimestampIfInSequenceMode(
+    int player_id,
+    const std::string& source_id,
+    const base::TimeDelta& timestamp_offset) {
+  MediaPlayerGStreamer* player = GetMediaPlayer(player_id);
+  if (player) {
+    player->SetGroupStartTimestampIfInSequenceMode(source_id, timestamp_offset);
+  }
+}
+
+void MediaChannel::OnMediaPlayerRemoveSegment(int player_id,
+                                              const std::string& source_id,
+                                              const base::TimeDelta& start,
+                                              const base::TimeDelta& end) {
+  MediaPlayerGStreamer* player = GetMediaPlayer(player_id);
+  if (player) {
+    player->RemoveSegment(source_id, start, end);
+  }
+}
+
+void MediaChannel::OnMediaPlayerAddKey(int player_id,
+                                       const std::string& session_id,
+                                       const std::string& key_id,
+                                       const std::string& key) {
+  MediaPlayerGStreamer* player = GetMediaPlayer(player_id);
+  if (player) {
+    player->AddKey(session_id, key_id, key);
+  }
+}
+
+void MediaChannel::SendMediaError(int player_id, int error) {
+  Send(new MediaPlayerMsg_MediaError(player_id, error));
+}
+
+void MediaChannel::SendMediaPlaybackCompleted(int player_id) {
+  Send(new MediaPlayerMsg_MediaPlaybackCompleted(player_id));
+}
+
+void MediaChannel::SendMediaDurationChanged(int player_id,
+                                            const base::TimeDelta& duration) {
+  Send(new MediaPlayerMsg_MediaDurationChanged(player_id, duration));
+}
+
+void MediaChannel::SendSeekCompleted(int player_id,
+                                     const base::TimeDelta& current_time) {
+  Send(new MediaPlayerMsg_SeekCompleted(player_id, current_time));
+}
+
+void MediaChannel::SendMediaVideoSizeChanged(int player_id,
+                                             int width,
+                                             int height) {
+  Send(new MediaPlayerMsg_MediaVideoSizeChanged(player_id, width, height));
+}
+
+void MediaChannel::SendMediaTimeUpdate(int player_id,
+                                       base::TimeDelta current_timestamp,
+                                       base::TimeTicks current_time_ticks) {
+  Send(new MediaPlayerMsg_MediaTimeUpdate(player_id, current_timestamp,
+                                          current_time_ticks));
+}
+
+void MediaChannel::SendBufferingUpdate(int player_id, int percent) {
+  Send(new MediaPlayerMsg_MediaBufferingUpdate(player_id, percent));
+}
+
+void MediaChannel::SendMediaPlayerReleased(int player_id) {
+  Send(new MediaPlayerMsg_MediaPlayerReleased(player_id));
+}
+
+void MediaChannel::SendDidMediaPlayerPlay(int player_id) {
+  Send(new MediaPlayerMsg_DidMediaPlayerPlay(player_id));
+}
+
+void MediaChannel::SendDidMediaPlayerPause(int player_id) {
+  Send(new MediaPlayerMsg_DidMediaPlayerPause(player_id));
+}
+
+void MediaChannel::SendSetCurrentFrame(int player_id,
+                                       int width,
+                                       int height,
+                                       unsigned texture_id,
+                                       unsigned target,
+                                       const std::vector<int32_t>& name) {
+  Send(new MediaPlayerMsg_SetCurrentFrame(player_id, width, height, texture_id,
+                                          target, name));
+}
+
+void MediaChannel::SendSourceSelected(int player_id) {
+  Send(new MediaPlayerMsg_SourceSelected(player_id));
+}
+
+void MediaChannel::SendDidAddSourceId(int player_id,
+                                      const std::string& source_id) {
+  Send(new MediaPlayerMsg_DidAddSourceId(player_id, source_id));
+}
+
+void MediaChannel::SendDidRemoveSourceId(int player_id,
+                                         const std::string& source_id) {
+  Send(new MediaPlayerMsg_DidRemoveSourceId(player_id, source_id));
+}
+
+void MediaChannel::SendInitSegmentReceived(int player_id,
+                                           const std::string& source_id) {
+  Send(new MediaPlayerMsg_InitSegmentReceived(player_id, source_id));
+}
+
+void MediaChannel::SendBufferedRangeUpdate(
+    int player_id,
+    const std::string& source_id,
+    const std::vector<base::TimeDelta>& ranges) {
+  Send(new MediaPlayerMsg_BufferedRangeUpdate(player_id, source_id, ranges));
+}
+
+void MediaChannel::SendTimestampOffsetUpdate(
+    int player_id,
+    const std::string& source_id,
+    const base::TimeDelta& timestamp_offset) {
+  Send(new MediaPlayerMsg_TimestampOffsetUpdate(player_id, source_id,
+                                                timestamp_offset));
+}
+
+void MediaChannel::SendNeedKey(int player_id,
+                               const std::string& system_id,
+                               const std::vector<unsigned char>& init_data) {
+  Send(new MediaPlayerMsg_NeedKey(player_id, system_id, init_data));
+}
+
+bool MediaChannel::Send(IPC::Message* message) {
+  // The media process must never send a synchronous IPC message to the renderer
+  // process. This could result in deadlock.
+  DCHECK(!message->is_sync());
+
+  if (!channel_) {
+    delete message;
+    return false;
+  }
+
+  return channel_->Send(message);
+}
+
+}  // namespace content
diff --git a/content/common/media/media_channel.h b/content/common/media/media_channel.h
new file mode 100644
index 0000000..d6a8721
--- /dev/null
+++ b/content/common/media/media_channel.h
@@ -0,0 +1,154 @@
+// Copyright (c) 2015 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#ifndef CONTENT_COMMON_MEDIA_MEDIA_CHANNEL_H_
+#define CONTENT_COMMON_MEDIA_MEDIA_CHANNEL_H_
+
+#include <deque>
+#include <string>
+
+#include "base/id_map.h"
+#include "base/containers/scoped_ptr_hash_map.h"
+#include "base/memory/ref_counted.h"
+#include "base/memory/scoped_ptr.h"
+#include "base/memory/scoped_vector.h"
+#include "base/memory/weak_ptr.h"
+#include "base/process/process.h"
+#include "build/build_config.h"
+#include "content/common/message_router.h"
+#include "ipc/ipc_sync_channel.h"
+#include "url/gurl.h"
+
+namespace base {
+class WaitableEvent;
+}
+
+namespace IPC {
+class MessageFilter;
+}
+
+namespace content {
+class MediaChannelFilter;
+class MediaPlayerGStreamer;
+
+// Encapsulates an IPC channel between the media process and one renderer
+// process. On the renderer side there's a corresponding web media player.
+class MediaChannel : public IPC::Listener, public IPC::Sender {
+ public:
+  // Takes ownership of the renderer process handle.
+  MediaChannel(int, MediaChannelFilter*);
+  ~MediaChannel() override;
+
+  void Init(base::SingleThreadTaskRunner* io_task_runner,
+            base::WaitableEvent* shutdown_event);
+
+  // Returns the name of the associated IPC channel.
+  std::string GetChannelName();
+
+#if defined(OS_POSIX)
+  base::ScopedFD TakeRendererFileDescriptor();
+#endif  // defined(OS_POSIX)
+
+  base::ProcessId renderer_pid() const { return channel_->GetPeerPID(); }
+
+  int client_id() const { return client_id_; }
+
+  MediaPlayerGStreamer* GetMediaPlayer(int player_id);
+
+  // IPC::Listener implementation:
+  bool OnMessageReceived(const IPC::Message& msg) override;
+  void OnChannelError() override;
+
+  void OnMediaPlayerCreate(int player_id);
+  void OnMediaPlayerLoad(int player_id, GURL url, unsigned position_update_interval_ms);
+  void OnMediaPlayerStart(int player_id);
+  void OnMediaPlayerPause(int player_id);
+  void OnMediaPlayerSeek(int player_id, base::TimeDelta delta);
+  void OnMediaPlayerRelease(int player_id);
+  void OnMediaPlayerReleaseTexture(int player_id, unsigned texture_id);
+  void OnMediaPlayerAddSourceId(int player_id,
+                                const std::string& source_id,
+                                const std::string& type,
+                                const std::vector<std::string>& codecs);
+  void OnMediaPlayerRemoveSourceId(int player_id, const std::string& source_id);
+  void OnMediaPlayerSetDuration(int player_id, const base::TimeDelta& duration);
+  void OnMediaPlayerMarkEndOfStream(int player_id);
+  void OnMediaPlayerUnmarkEndOfStream(int player_id);
+  void OnMediaPlayerSetSequenceMode(int player_id,
+                                    const std::string& source_id,
+                                    bool sequence_mode);
+  void OnMediaPlayerAppendData(int player_id,
+                               const std::string& source_id,
+                               const std::vector<unsigned char>& data,
+                               const std::vector<base::TimeDelta>& times);
+  void OnMediaPlayerAbort(int player_id, const std::string& source_id);
+  void OnMediaPlayerSetGroupStartTimestampIfInSequenceMode(
+      int player_id,
+      const std::string& source_id,
+      const base::TimeDelta& timestamp_offset);
+  void OnMediaPlayerRemoveSegment(int player_id,
+                                  const std::string& source_id,
+                                  const base::TimeDelta& start,
+                                  const base::TimeDelta& end);
+  void OnMediaPlayerAddKey(int player_id,
+                           const std::string& session_id,
+                           const std::string& key_id,
+                           const std::string& key);
+
+  // IPC::Sender implementation:
+  bool Send(IPC::Message* msg) override;
+
+  void SendMediaError(int player_id, int error);
+  void SendMediaPlaybackCompleted(int player_id);
+  void SendMediaDurationChanged(int player_id, const base::TimeDelta& duration);
+  void SendSeekCompleted(int player_id, const base::TimeDelta& current_time);
+  void SendMediaVideoSizeChanged(int player_id, int width, int height);
+  void SendMediaTimeUpdate(int player_id,
+                           base::TimeDelta current_timestamp,
+                           base::TimeTicks current_time_ticks);
+  void SendBufferingUpdate(int player_id, int percent);
+  void SendMediaPlayerReleased(int player_id);
+  void SendDidMediaPlayerPlay(int player_id);
+  void SendDidMediaPlayerPause(int player_id);
+  void SendSetCurrentFrame(int player_id,
+                           int width,
+                           int height,
+                           unsigned texture_id,
+                           unsigned target,
+                           const std::vector<int32_t>& name);
+  void SendSourceSelected(int player_id);
+  void SendDidAddSourceId(int player_id, const std::string& source_id);
+  void SendDidRemoveSourceId(int player_id, const std::string& source_id);
+  void SendInitSegmentReceived(int player_id, const std::string& source_id);
+  void SendBufferedRangeUpdate(int player_id,
+                               const std::string& source_id,
+                               const std::vector<base::TimeDelta>& ranges);
+  void SendTimestampOffsetUpdate(int player_id,
+                                 const std::string& source_id,
+                                 const base::TimeDelta& timestamp_offset);
+  void SendNeedKey(int player_id,
+                   const std::string& system_id,
+                   const std::vector<unsigned char>& init_data);
+
+ private:
+  scoped_ptr<IPC::SyncChannel> channel_;
+
+  // The id of the client who is on the other side of the channel.
+  int client_id_;
+
+  // Uniquely identifies the channel within this GPU process.
+  std::string channel_id_;
+
+  scoped_refptr<MediaChannelFilter> channel_filter_;
+
+  typedef base::ScopedPtrHashMap<int, scoped_ptr<MediaPlayerGStreamer>>
+      MediaPlayerMap;
+  MediaPlayerMap media_players_;
+
+  DISALLOW_COPY_AND_ASSIGN(MediaChannel);
+};
+
+}  // namespace content
+
+#endif  // CONTENT_COMMON_MEDIA_MEDIA_CHANNEL_H_
diff --git a/content/common/media/media_channel_filter.cc b/content/common/media/media_channel_filter.cc
new file mode 100644
index 0000000..5870b1d
--- /dev/null
+++ b/content/common/media/media_channel_filter.cc
@@ -0,0 +1,97 @@
+// Copyright (c) 2015 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#include "media_channel_filter.h"
+
+#include "base/bind.h"
+#include "base/command_line.h"
+#include "content/child/child_thread_impl.h"
+#include "content/common/media/media_channel.h"
+#include "content/common/media/media_messages.h"
+#include "content/common/message_router.h"
+#include "ipc/message_filter.h"
+
+namespace content {
+
+MediaChannelFilter::MediaChannelFilter(
+    MessageRouter* router,
+    base::SingleThreadTaskRunner* io_task_runner,
+    base::WaitableEvent* shutdown_event,
+    IPC::SyncChannel* channel,
+    MediaPlayerGStreamerFactory* media_player_factory)
+    : io_task_runner_(io_task_runner),
+      shutdown_event_(shutdown_event),
+      router_(router),
+      channel_(channel),
+      media_player_factory_(media_player_factory),
+      weak_factory_(this) {
+  DCHECK(router_);
+  DCHECK(io_task_runner);
+  DCHECK(shutdown_event);
+}
+
+MediaChannelFilter::~MediaChannelFilter() {
+  media_channels_.clear();
+}
+
+void MediaChannelFilter::RemoveChannel(int client_id) {
+  media_channels_.erase(client_id);
+}
+
+MediaChannel* MediaChannelFilter::LookupChannel(int32 client_id) {
+  MediaChannelMap::const_iterator iter = media_channels_.find(client_id);
+  if (iter == media_channels_.end())
+    return NULL;
+  else
+    return iter->second;
+}
+
+bool MediaChannelFilter::OnMessageReceived(const IPC::Message& msg) {
+  bool handled = true;
+  IPC_BEGIN_MESSAGE_MAP(MediaChannelFilter, msg)
+    IPC_MESSAGE_HANDLER(MediaMsg_EstablishChannel, OnEstablishChannel)
+    IPC_MESSAGE_HANDLER(MediaMsg_CloseChannel, OnCloseChannel)
+    IPC_MESSAGE_UNHANDLED(handled = false)
+  IPC_END_MESSAGE_MAP()
+  return handled;
+}
+
+bool MediaChannelFilter::Send(IPC::Message* msg) {
+  return router_->Send(msg);
+}
+
+void MediaChannelFilter::OnEstablishChannel(int client_id) {
+  DCHECK_NE(io_task_runner_.get(), base::ThreadTaskRunnerHandle::Get().get());
+
+  IPC::ChannelHandle channel_handle;
+
+  scoped_ptr<MediaChannel> channel(new MediaChannel(client_id, this));
+  channel->Init(io_task_runner_.get(), shutdown_event_);
+  channel_handle.name = channel->GetChannelName();
+
+#if defined(OS_POSIX)
+  // On POSIX, pass the renderer-side FD. Also mark it as auto-close so
+  // that it gets closed after it has been sent.
+  base::ScopedFD renderer_fd = channel->TakeRendererFileDescriptor();
+  DCHECK(renderer_fd.is_valid());
+  channel_handle.socket = base::FileDescriptor(renderer_fd.Pass());
+#endif
+
+  media_channels_.set(client_id, channel.Pass());
+
+  Send(new MediaHostMsg_ChannelEstablished(channel_handle));
+}
+
+void MediaChannelFilter::OnCloseChannel(
+    const IPC::ChannelHandle& channel_handle) {
+  for (MediaChannelMap::iterator iter = media_channels_.begin();
+       iter != media_channels_.end(); ++iter) {
+    if (iter->second->GetChannelName() == channel_handle.name) {
+      media_channels_.erase(iter);
+      return;
+    }
+  }
+}
+
+}  // namespace content
diff --git a/content/common/media/media_channel_filter.h b/content/common/media/media_channel_filter.h
new file mode 100644
index 0000000..0fcd540
--- /dev/null
+++ b/content/common/media/media_channel_filter.h
@@ -0,0 +1,99 @@
+// Copyright (c) 2015 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#ifndef CONTENT_COMMON_MEDIA_MEDIA_CHANNEL_FILTER_H_
+#define CONTENT_COMMON_MEDIA_MEDIA_CHANNEL_FILTER_H_
+
+#include <deque>
+#include <string>
+#include <vector>
+
+#include "base/containers/scoped_ptr_hash_map.h"
+#include "base/memory/ref_counted.h"
+#include "base/memory/scoped_ptr.h"
+#include "base/memory/weak_ptr.h"
+#include "build/build_config.h"
+#include "content/common/content_export.h"
+#include "content/common/content_param_traits.h"
+#include "content/media/gstreamer/media_player_gstreamer.h"
+#include "ipc/ipc_listener.h"
+#include "ipc/ipc_sender.h"
+#include "ipc/message_filter.h"
+
+namespace base {
+class WaitableEvent;
+}
+
+namespace IPC {
+struct ChannelHandle;
+class SyncChannel;
+// class MessageFilter;
+}
+
+namespace content {
+class MediaChannel;
+class MediaPlayerGStreamerFactory;
+class MessageRouter;
+
+// A MediaChannelManager is responsible for managing the lifetimes of media
+// channels and forwarding IPC requests from the
+// browser process to them based on the corresponding renderer ID.
+class CONTENT_EXPORT MediaChannelFilter : public IPC::MessageFilter {
+ public:
+  MediaChannelFilter(MessageRouter* router,
+                     base::SingleThreadTaskRunner* io_task_runner,
+                     base::WaitableEvent* shutdown_event,
+                     IPC::SyncChannel* channel,
+                     MediaPlayerGStreamerFactory* media_player_factory);
+  ~MediaChannelFilter() override;
+
+  // Remove the channel for a particular renderer.
+  void RemoveChannel(int client_id);
+
+  // Listener overrides.
+  bool OnMessageReceived(const IPC::Message& msg) override;
+
+  // Sender overrides.
+  bool Send(IPC::Message* msg);
+
+  bool HandleMessagesScheduled();
+  uint64 MessagesProcessed();
+
+  MediaChannel* LookupChannel(int32 client_id);
+  MediaPlayerGStreamerFactory* GetMediaPlayerFactory() {
+    return media_player_factory_.get();
+  }
+
+ private:
+  typedef base::ScopedPtrHashMap<int, scoped_ptr<MediaChannel>> MediaChannelMap;
+
+  // Message handlers.
+  void OnEstablishChannel(int client_id);
+  void OnCloseChannel(const IPC::ChannelHandle& channel_handle);
+
+  scoped_refptr<base::SingleThreadTaskRunner> io_task_runner_;
+  base::WaitableEvent* shutdown_event_;
+
+  // Used to send and receive IPC messages from the browser process.
+  MessageRouter* const router_;
+
+  // These objects manage channels to individual renderer processes there is
+  // one channel for each renderer process that has connected to this media
+  // process.
+  MediaChannelMap media_channels_;
+  IPC::SyncChannel* channel_;
+  scoped_refptr<IPC::MessageFilter> filter_;
+  scoped_ptr<MediaPlayerGStreamerFactory> media_player_factory_;
+
+  // Member variables should appear before the WeakPtrFactory, to ensure
+  // that any WeakPtrs to Controller are invalidated before its members
+  // variable's destructors are executed, rendering them invalid.
+  base::WeakPtrFactory<MediaChannelFilter> weak_factory_;
+
+  DISALLOW_COPY_AND_ASSIGN(MediaChannelFilter);
+};
+
+}  // namespace content
+
+#endif  // CONTENT_COMMON_MEDIA_MEDIA_CHANNEL_FILTER_H_
diff --git a/content/common/media/media_channel_host.cc b/content/common/media/media_channel_host.cc
new file mode 100644
index 0000000..ae7d19e
--- /dev/null
+++ b/content/common/media/media_channel_host.cc
@@ -0,0 +1,151 @@
+// Copyright (c) 2015 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#include "media_channel_host.h"
+
+#include <algorithm>
+
+#include "base/bind.h"
+#include "base/message_loop/message_loop.h"
+#include "base/posix/eintr_wrapper.h"
+#include "base/threading/thread_restrictions.h"
+#include "base/trace_event/trace_event.h"
+#include "content/child/child_process.h"
+#include "content/common/media/media_messages.h"
+#include "content/public/child/child_thread.h"
+#include "content/renderer/media/gstreamer/webmediaplayer_gstreamer.h"
+#include "ipc/ipc_sync_message_filter.h"
+#include "url/gurl.h"
+
+using base::AutoLock;
+
+namespace content {
+
+// static
+scoped_refptr<MediaChannelHost> MediaChannelHost::Create(
+    const IPC::ChannelHandle& channel_handle,
+    base::WaitableEvent* shutdown_event) {
+  scoped_refptr<MediaChannelHost> dispatcher = new MediaChannelHost;
+  dispatcher->Connect(channel_handle, shutdown_event);
+  return dispatcher;
+}
+
+MediaChannelHost::MediaChannelHost() {}
+
+static bool IsMainThread() {
+  return !!ChildThread::Get();
+}
+
+void MediaChannelHost::Connect(const IPC::ChannelHandle& channel_handle,
+                               base::WaitableEvent* shutdown_event) {
+  // Open a channel to the media process. We pass NULL as the main listener here
+  // since we need to filter everything to route it to the right thread.
+  channel_ = IPC::SyncChannel::Create(
+      channel_handle, IPC::Channel::MODE_CLIENT, NULL,
+      ChildProcess::current()->io_task_runner(), true, shutdown_event);
+
+  sync_filter_ = new IPC::SyncMessageFilter(shutdown_event);
+
+  channel_->AddFilter(sync_filter_.get());
+
+  channel_filter_ = new MessageFilter();
+
+  // Install the filter last, because we intercept all leftover
+  // messages.
+  channel_->AddFilter(channel_filter_.get());
+}
+
+bool MediaChannelHost::Send(IPC::Message* msg) {
+  scoped_ptr<IPC::Message> message(msg);
+  // The media process never sends synchronous IPCs so clear the unblock flag to
+  // preserve order.
+  message->set_unblock(false);
+
+  if (IsMainThread()) {
+    base::ThreadRestrictions::ScopedAllowWait allow_wait;
+    bool result = channel_->Send(message.release());
+    if (!result)
+      DVLOG(1) << "MediaChannelHost::Send failed: Channel::Send failed";
+    return result;
+  }
+
+  bool result = sync_filter_->Send(message.release());
+  return result;
+}
+
+void MediaChannelHost::DestroyChannel() {
+  DCHECK(IsMainThread());
+  channel_.reset();
+}
+
+void MediaChannelHost::RegisterDispatcher(
+    int player_id,
+    media::WebMediaPlayerMessageDispatcher* dispatcher) {
+  channel_filter_->RegisterDispatcher(player_id, dispatcher);
+}
+
+void MediaChannelHost::RemoveDispatcher(int player_id) {
+  channel_filter_->RemoveDispatcher(player_id);
+}
+
+MediaChannelHost::~MediaChannelHost() {
+  DestroyChannel();
+}
+
+MediaChannelHost::MessageFilter::MessageFilter() : lost_(false) {}
+
+MediaChannelHost::MessageFilter::~MessageFilter() {}
+
+void MediaChannelHost::MessageFilter::RegisterDispatcher(
+    int player_id,
+    media::WebMediaPlayerMessageDispatcher* dispatcher) {
+  dispatchers_[player_id] = dispatcher;
+}
+
+void MediaChannelHost::MessageFilter::RemoveDispatcher(int player_id) {
+  dispatchers_.erase(player_id);
+}
+
+bool MediaChannelHost::MessageFilter::OnMessageReceived(
+    const IPC::Message& message) {
+  // Never handle sync message replies or we will deadlock here.
+  if (message.is_reply())
+    return false;
+
+  WebMediaPlayerDispatcherMap::iterator iter =
+      dispatchers_.find(message.routing_id());
+  if (iter == dispatchers_.end())
+    return false;
+
+  media::WebMediaPlayerMessageDispatcher* dispatcher = iter->second;
+  scoped_refptr<base::SingleThreadTaskRunner> taskRunner =
+      dispatcher->GetTaskRunner();
+  base::WeakPtr<IPC::Listener> listener = dispatcher->AsWeakPtr();
+
+  taskRunner->PostTask(
+      FROM_HERE,
+      base::Bind(base::IgnoreResult(&IPC::Listener::OnMessageReceived),
+                 listener, message));
+
+  return true;
+}
+
+void MediaChannelHost::MessageFilter::OnChannelError() {
+  // Set the lost state before signalling the proxies. That way, if they
+  // themselves post a task to recreate the context, they will not try to re-use
+  // this channel host.
+  {
+    AutoLock lock(lock_);
+    lost_ = true;
+  }
+
+  dispatchers_.clear();
+}
+
+bool MediaChannelHost::MessageFilter::IsLost() const {
+  AutoLock lock(lock_);
+  return lost_;
+}
+
+}  // namespace content
